local CamState = 0
local Target = 0
local FStr = ""
local Jswitch = 1
local NoTar = 0
local TLost = 0
local SPlate = ""

BINDING_HEADER_ZTARGETING = "Z-Targeting";
BINDING_HEADER_BOSS_INFO = "Boss Info";

function ZT_Load(self) 
	self:RegisterEvent("PLAYER_TARGET_CHANGED");
	-- self:RegisterEvent("NAME_PLATE_CREATED");
	self:RegisterEvent("NAME_PLATE_UNIT_ADDED");
	self:RegisterEvent("NAME_PLATE_UNIT_REMOVED");
	
	SLASH_ZTMe1 = "/ZTMe";
	SlashCmdList["ZTMe"] = ZTMe_Slash;
	-- ConsoleExec("ActionCam off")
	CamState = 0
	
	if fairy == nil then
		fairy = "Navi"
	end
	
	if ModStatus == nil then
		ModStatus = 1
		mstate = "on"
	elseif ModStatus == 1 then
		mstate = "on"
	else
		mstate = "off"
	end
	
	DEFAULT_CHAT_FRAME:AddMessage("Z-Target Me loaded! Mod status is " .. mstate .. ".");
	DEFAULT_CHAT_FRAME:AddMessage("-----");
	DEFAULT_CHAT_FRAME:AddMessage("Welcome to Z-Target Me! This addon is currently in beta.");
	DEFAULT_CHAT_FRAME:AddMessage("If third party sounds are still disabled, please copy the sound folder to the parent WoW folder (be it beta or public test) if you'd like to hear them! Thanks!");	
end

function ZTMe_Slash(cmd)
	if strlower(cmd) == "" then
		DEFAULT_CHAT_FRAME:AddMessage("Z-Target Me! Commands:");
		DEFAULT_CHAT_FRAME:AddMessage("'/ZTMe on' or '/ZTMe off' for addon (de)activation.");
		DEFAULT_CHAT_FRAME:AddMessage("'/ZTMe none', '/ZTMe navi', or '/ZTMe tatl' for fairy sounds.");
		
	elseif strlower(cmd) == "on" then
		if (ModStatus == 1) then
			DEFAULT_CHAT_FRAME:AddMessage("Z-Targeting is already enabled.");
			PlaySoundFile("Sound\\Fairies\\" .. fairy .. "\\Hey.ogg")
		else
			ModStatus = 1
			DEFAULT_CHAT_FRAME:AddMessage("Z-Targeting enabled.");
			PlaySoundFile("Sound\\Fairies\\" .. fairy .. "\\Out.ogg")
		end
		
	elseif strlower(cmd) == "off" then
		if (ModStatus == 0) then
			DEFAULT_CHAT_FRAME:AddMessage("Z-Targeting is already disabled.");
			PlaySoundFile("Sound\\Fairies\\" .. fairy .. "\\Hey.ogg")
		else
			ModStatus = 0
			DEFAULT_CHAT_FRAME:AddMessage("Z-Targeting disabled.");
			PlaySoundFile("Sound\\Fairies\\" .. fairy .. "\\Away.ogg")
		end
		
	elseif strlower(cmd) == "none" then
		PlaySoundFile("Sound\\Fairies\\" .. fairy .. "\\Away.ogg")
		fairy = ""
		DEFAULT_CHAT_FRAME:AddMessage("Fairy set to Silent.");
		
	elseif strlower(cmd) == "shut up" or strlower(cmd) == "shutup" or strlower(cmd) == "fuck off" or strlower(cmd) == "fuckoff" then
		PlaySoundFile("Sound\\Fairies\\" .. fairy .. "\\Sad.ogg")
		PlaySoundFile("Sound\\Fairies\\Bonk.ogg")
		fairy = ""
		DEFAULT_CHAT_FRAME:AddMessage("Fairy set to Silent... jerk.");
		
	elseif strlower(cmd) == "navi" then
		fairy = "Navi"
		DEFAULT_CHAT_FRAME:AddMessage("Fairy set to Navi.");
		PlaySoundFile("Sound\\Fairies\\" .. fairy .. "\\Hello.ogg")
	
	elseif strlower(cmd) == "tatl" then
		fairy = "Tatl"
		DEFAULT_CHAT_FRAME:AddMessage("Fairy set to Tatl.");
		PlaySoundFile("Sound\\Fairies\\" .. fairy .. "\\Hello.ogg")
		
	end		
end

function ZTarget()
	local tarplate = C_NamePlate.GetNamePlateForUnit("target")

	if not IsAddOnLoaded("Blizzard_EncounterJournal") then
		LoadAddOn("Blizzard_EncounterJournal")
	end

	if (ModStatus == 1) then
		if (CamState == 0) then
			if(UnitExists("target")) and not (UnitIsUnit("target", "player")) and tarplate ~= nil then
				ConsoleExec("ActionCam focusOn")
				CamState = 1
				Reticule(tarplate, event)	
				ZSound()
			else
				if (CamState == 0) then
					CameraZoomIn(2)
					ConsoleExec("ActionCam full")
					CamState = 1
					NoTar = 1
				
					PlaySoundFile("Sound\\centernormal.ogg")
				else
					ConsoleExec("ActionCam off")
					CamState = 0
				end
			end
		else
			Target = 0
			ConsoleExec("ActionCam off")
			CamState = 0
			TLost = 0
			
			if(UnitExists("target")) and NoTar == 0 then
				PlaySoundFile("Sound\\cancel.ogg")
			end
			
			if NoTar == 1 then
				CameraZoomOut(2)
				NoTar = 0
			end
			
			Reticule(tarplate, event)
		end
	end
end

function ZChange(self, event)
	local tarplate = C_NamePlate.GetNamePlateForUnit("target")
	local i = 0

	if (ModStatus == 1) then
		if event =="PLAYER_TARGET_CHANGED" then 
			if (CamState == 1) then
				if(UnitExists("target")) and not (UnitIsUnit("target", "player")) and tarplate ~= nil then
					Reticule(tarplate, event)
					ZSound()
					
					if NoTar == 1 then
						CameraZoomOut(2)
						NoTar = 0
					end		
				else
					Target = 0
					ConsoleExec("ActionCam off")
					CamState = 0
					TLost = 0
					
					if NoTar == 1 then
						CameraZoomOut(2)
						NoTar = 0
					end
				
					PlaySoundFile("Sound\\cancel.ogg")
					Reticule(tarplate, event)
				end
			end
		end	
	end
end


-- Textures
local r = CreateFrame('frame', "tarframe", WorldFrame)
	r:SetFrameLevel(0)
	r:SetFrameStrata('BACKGROUND')
	r:SetSize(64, 64)

local ret = r:CreateTexture("Target", "BACKGROUND")
	ret:SetTexture([[Interface\addons\ZTargetMe\target]])
	ret:SetAllPoints(r)
	ret:SetAlpha(1)
	
local ani = ret:CreateAnimationGroup()
local rota = ani:CreateAnimation("Rotation")
	rota:SetDegrees(-360)
	rota:SetDuration(3)
	ani:SetLooping("REPEAT")
	ani:Play()

function ZSound()	
	local calc = ZLevelCalc()
	
	if UnitIsPlayer("target") then
		if UnitIsPVP("target") and UnitIsEnemy("player", "target") then
			if UnitIsPVP("player") then
				PlaySoundFile("Sound\\Fairies\\" .. fairy .. "\\WatchOut.ogg")
				PlaySoundFile("Sound\\targethostile.ogg")
				ret:SetVertexColor(1, 0, 0)
			else
				PlaySoundFile("Sound\\Fairies\\" .. fairy .. "\\Hey.ogg")
				PlaySoundFile("Sound\\targethostile.ogg")
				ret:SetVertexColor(1, 1, 0)
			end
		else
			if UnitIsPVP("player") then
				PlaySoundFile("Sound\\Fairies\\" .. fairy .. "\\WatchOut.ogg")
				PlaySoundFile("Sound\\targetfriendly.ogg")
				ret:SetVertexColor(0, 1, 0)
			else
				PlaySoundFile("Sound\\targetfriendly.ogg")
				ret:SetVertexColor(0, 1, 0)
			end
		end
	else
		if UnitIsEnemy("player", "target") then
			if UnitIsDead("target") then
				PlaySoundFile("Sound\\targetfriendly.ogg")
				ret:SetVertexColor(1, 1, 0)
			else
				if calc == "boss" or calc == "red" then
					PlaySoundFile("Sound\\Fairies\\" .. fairy .. "\\WatchOut.ogg")
					ret:SetVertexColor(1, 0, 0)
				else
					PlaySoundFile("Sound\\Fairies\\" .. fairy .. "\\Hey.ogg")
					
					if calc == "orange" then
						ret:SetVertexColor(1, 0.5, 0)
					else
						ret:SetVertexColor(1, 1, 0)
					end
				end
				
				PlaySoundFile("Sound\\targethostile.ogg")
			end
		elseif UnitIsFriend("player", "target") then
			PlaySoundFile("Sound\\targetfriendly.ogg")
			ret:SetVertexColor(0, 1, 0)
		else
			if UnitIsDead("target") then
				PlaySoundFile("Sound\\targetfriendly.ogg")
				ret:SetVertexColor(1, 1, 0)
			else
				if calc == "boss" or calc == "red" then
					PlaySoundFile("Sound\\Fairies\\" .. fairy .. "\\WatchOut.ogg")
				elseif calc == notboss then
					PlaySoundFile("Sound\\Fairies\\" .. fairy .. "\\Hey.ogg")
				end
				
				ret:SetVertexColor(1, 1, 0)
				PlaySoundFile("Sound\\targethostile.ogg")
			end
		end
	end
end

function BossInfo()
	local tarplate = C_NamePlate.GetNamePlateForUnit("target")

	if CamState == 1 and UnitExists("target") and tarplate ~= nil then
		local ins = EJ_GetCurrentInstance()
		local dif = EJ_GetDifficulty()
		local ind = 1
		local boss, desc, encID, secID, lk = ""
		local tarNam = UnitName("target")
		
		-- EncounterJournal_OpenJournal(dif, ins, nil, nil, nil, nil)

		-- repeat
			-- boss, desc, encID, secID, lk = EJ_GetEncounterInfoByIndex(ind, ins)

			-- if boss == nil then
				-- DEFAULT_CHAT_FRAME:AddMessage("Unit has no entry.");
				-- DEFAULT_CHAT_FRAME:AddMessage("DEBUG: Boss:" .. boss .. " EncID: " .. encID .. " ind: " .. ind); -- DEBUG
				-- return
			-- else
				-- ind = (ind + 1)
			-- end
		-- until boss == tarNam

		-- if boss == "" then
			-- return "noboss"
		-- else
			-- local bossID, bname, bdesc, dInfo, icImg = EJ_GetCreatureInfo(ind, encID)

			-- if pcall(EncounterJournal_OpenJournal(dif, ins, encID, secID, bossID, nil)) then
				PlaySoundFile("Sound\\Fairies\\" .. fairy .. "\\Listen.ogg")
				-- return
			-- else
				-- DEFAULT_CHAT_FRAME:AddMessage("Error in Dungeon Journal handling!");
				-- DEFAULT_CHAT_FRAME:AddMessage("DEBUG: Boss:" .. boss .. " EncID: " .. encID .. " ind: " .. ind); -- DEBUG
				-- return
			-- end
		-- end
	end



	-- if CamState == 1 and UnitExists("target") then
	-- -- EJ_GetCurrentInstance() -- for Instance ID
	-- -- EJ_GetEncounterInfoByIndex -- to find encounter info
	-- -- Loop until name matches target name, grab encounter info for journal stuff
	
	
	
	
		-- local difficulty = EJ_GetDifficulty()
		-- local boss, x, server, instance, zone, id, spawn = UnitGUID("target")
		
		-- EncounterJournal_OpenJournal(difficulty, instance, nil, nil, id, nil)

		-- DEFAULT_CHAT_FRAME:AddMessage("This will hopefully give targeted boss info later.");
		-- PlaySoundFile("Sound\\Fairies\\" .. fairy .. "\\Listen.ogg")
	-- end
end

function ZLevelCalc()
	local TLvl = 0
	local PLvl = UnitLevel("player")
	local LvlDif = 0

	TLvl = UnitLevel("target")
			
	if not (TLvl == -1) then
		LvlDif = (TLvl - PLvl)
	else
		LvlDif = 666
	end
	
	-- DEFAULT_CHAT_FRAME:AddMessage(LvlDif); --Debugging Function
			
	if LvlDif == 666 then 
		return "boss"
	elseif LvlDif >= 5 then	
		return "red"
	elseif LvlDif == 3 or LvlDif == 4 then
		return "orange"
	elseif LvlDif > -3 and LvlDif < 3 then
		return "yellow"
	end 	
end

function Reticule(tarplate, event)
	if CamState == 1 and UnitExists("target") then	
		tarplate = C_NamePlate.GetNamePlateForUnit("target")
		
		if tarplate ~= nil then
			local x, y = tarplate:GetCenter()
				
			r:SetAlpha(1)	
			r:SetPoint("CENTER", tarplate, 0, -60)
		end
	else
		r:SetAlpha(0)
	end
end

function ZOffScreen(self, event)
	if CamState == 1 and NoTar ~= 1 then	
		if event == "NAME_PLATE_UNIT_REMOVED" then			
			local tarplate = C_NamePlate.GetNamePlateForUnit("target")
				
				if tarplate == nil then					
					r:SetAlpha(0)
					Target = 0
					ConsoleExec("ActionCam off")
					CamState = 0
					TLost = 1
					PlaySoundFile("Sound\\cancel.ogg")
				end
		end
	end			
end

function ZOnScreen(self, event)
	if CamState == 0 and TLost == 1 then
		if event == "NAME_PLATE_UNIT_ADDED" then
			local tarplate = C_NamePlate.GetNamePlateForUnit("target")
		
			if tarplate ~= nil then
				ConsoleExec("ActionCam focusOn")
				CamState = 1
				Reticule(tarplate, event)	
				ZSound()
				TLost = 0
			end
		end
	end
end